
Auto Multiple Choice - Bug # 251: AMCOpen is broken. produces LaTeX Error: There's no line here to 
end.

Status: Closed Priority: High
Author: Pieter  Van den Hombergh Category: LaTeX
Created: 01/02/2014 Assignee: Anirvan Sarkar
Updated: 08/19/2014 Due date:
Description: When using \\AMCOpen, it produces the mentioned latex error.

sample code
<pre>
\begin{question}{xml-ooXML01}  [4 Points]

This question is about an XML document.

\begin{itemize}
\item
    Which node always has to be present in an XML tree?
\end{itemize}
    

  \AMCOpen{lines=1}{
    \wrongchoice[W]{0}\scoring{0}
    \correctchoice[C]{1}\scoring{4}
  }

\end{question}
</pre>

when \AMCOpen is redefined in a macro file (which is included after the automul style file) as follows, the 
error is gone.

*fix:*
<pre>
\def\AMCOpen{\hfill\AMCformatChoices{\AMCopenShow}{\AMCopenHide}}
</pre>
stops latex from complaining.

The fix appears not to have any other effect then to fill out the line, so latex will happily end the line.

History
01/03/2014 06:01 pm - Anirvan Sarkar
Pieter  Van den Hombergh wrote:
> The fix appears not to have any other effect then to fill out the line, so latex will happily end the line.

This will not produce a proper formatting if the @separateanswersheet@ option is used. An extra line will be printed after the open question.

But it helped me locate where the problem is. The error is caused due to this line in the definition of @\AMCopenShow@ command:
<pre>
\linebreak[1]\hspace*{\fill}%
</pre>A line break only works if a paragraph has started otherwise LaTeX will give the error: _There's no line here to end._
A new paragraph does not automatically start after the end of an environment (in your case the @itemize@ environment) and the @\AMCOpen@ 
internally uses a linebreak. These two factors contributed to this error.

The easiest way to fix this is to add a space before the linebreak.
<pre>
~\linebreak[1]\hspace*{\fill}%
</pre>

01/03/2014 06:04 pm - Anonymous
- % Done changed from 0 to 100

- Status changed from New to Resolved

Applied in changeset r1502.

01/03/2014 06:39 pm - Pieter  Van den Hombergh
Hello Anrivan,

Your solution is most likely correct. I did not observe the extra line and my proposal was only a fix for the error.

I'll wait for Alexis to adapt you solution.

01/03/2014 06:45 pm - Pieter  Van den Hombergh
Pieter  Van den Hombergh wrote:
> Hello Anrivan,
> 
> Your solution is most likely correct. I did not observe the extra line and my proposal was only a fix for the error.
> 
> I'll wait for Alexis to adapt you solution.
Just updated and installed and your solution is correct.

04/07/2014 09:21 am - Anonymous
Applied in changeset commit:7300ca4e7b9a.

08/19/2014 06:19 am - Anirvan Sarkar
- Target version set to 1.3.0

- Assignee set to Anirvan Sarkar

- Status changed from Resolved to Closed
